/* jshint browser: true, devel: true, unused: true, globalstrict: true, esversion: 6*/
'use strict';

function setup() {
  let now=new Date();
  let year=now.getFullYear();
  let month=now.getMonth();
  let day=now.getDate();
  loadCalendar(year, month, day);
  loadRooms(year, month, day);
  setDate(year, month, day);
  let ulRooms = document.getElementById("rooms");
  ulRooms.addEventListener("click", bookRelease);
  let calendar = document.getElementById("calendar");
  calendar.addEventListener("click", loadRoomsEvent);
}



function release(/*room, year, mon, day, element*/){
  alert('Musisz doprogramować tę funkcję\n');
}

  
function book(room, year, month, day, element){
  fetch( `?data=book&room=${room}&month=${month}&year=${year}&day=${day}`)
  .then(response => {
     if(response.ok){
        return response.text();
     }
     else{
        throw new Error("Błąd: " + response.status);
     }
  })
  .then(
     text => {
        if(text == 'OK'){
            element.innerHTML='Zwolnij';
            element.parentElement.className='booked';
        }
        else{
           throw new Error("Nie udało się zarezerwować pokoju " + room + ": " + text);
        }
     }
   )
  .catch( error => alert(error));
}
  


function loadCalendar (year, month, day){
  let calendarElem = document.getElementById('calendar');
  fetch( `?data=calendar&month=${month}&year=${year}&day=${day}`)
  .then(response => {
     if(response.ok){
        return response.text();
     }
     else{
        throw new Error("Błąd: " + response.status);
     }
  })
  .then(
     text => {
        calendarElem.innerHTML = text;
     }
   )
  .catch( error => alert(error));
}

function bookRelease(event){
    let span = event.target;
    if(span.tagName != 'SPAN') return;
    let dateElement = document.getElementById('dat');
    let date = new Date(dateElement.datetime);
    let year = date.getFullYear();
    let month = date.getMonth();
    let day = date.getDate();
    let room = span.previousSibling.nodeValue.trim();
    if(span.textContent == 'Zarezerwuj'){
        book(room, year, month, day, span);
    }
    else{
        release(room, year, month, day, span);
    }
}

function loadRoomsEvent (){
    let td = event.target;
    if(td.tagName != 'TD') return;
    if(! /^\d+$/.test(td.textContent)) return;
    let dateElement = document.getElementById('dat');
    let date = new Date(dateElement.datetime);
    let year = date.getFullYear();
    let month = date.getMonth();
    let day = td.textContent;
    loadRooms(year, month, day);
}

function loadRooms(year, month, day){
  let roomsElem = document.getElementById('rooms');
  fetch( `?data=rooms&month=${month}&year=${year}&day=${day}`)
  .then(response => {
     if(response.ok){
        return response.text();
     }
     else{
        throw new Error("Błąd: " + response.status);
     }
  })
  .then(
     text => {
        roomsElem.innerHTML = text;
        setDate(year,month,day);
     }
   )
  .catch( error => alert(error));
}

function setDate (year, month, day){
  let date = new Date(year,month,day);
  let dateElement = document.getElementById('dat');
  dateElement.innerHTML=date.toLocaleDateString();
  dateElement.datetime=date.toISOString();
}


document.addEventListener('DOMContentLoaded', setup);
